
/* ---------------------------------------------

	[ raw2r16.c ]

	^LCD/OLEDpt@CtH[}bgϊ
	for Win32vbgtH[
	(c) 2010, By Y.Kyotani

--------------------------------------------- */

#include	<stdio.h>
#include	<string.h>
#include	<stdlib.h>

/* Header\ */
typedef	struct
	{
	char	idstr[6];
	short	interval;
	short	dispnops;
	short	dx;
	short	dy;
	short	ofsx;
	short	ofsy;
	char	filler[494];
	} HEADER;


/* ϐ` */
static	HEADER	header=
	{ "bgr16",0, 0, 0, 0, 0, 0, };

char	InName[128];
char	OutName[128];
char	FName[512];

unsigned char	inbuff[32],outbuff[32];

/* [J֐vg^Cv */
int filesub(void);


/* C֐F̉H */
int main(int argc, char *argv[])
	{
	if	(argc < 2)
		{
		printf	("̓t@C(*.raw)gqȂœ́F");
		gets	(InName);
		}
	else
		strcpy	(InName, argv[1]);

	if	(argc < 3)
		{
		printf	("o̓t@C(*.r16)gqȂœ́F");
		gets	(OutName);
		if	(*OutName == '\0')
			strcpy	(OutName, InName);
		}
	else
		strcpy	(OutName, argv[2]);


	printf	("摜xTCÝF");
	gets	(FName);
	header.dx= atoi(FName);

	return	(filesub());
	}

/* t@CJĉH鏈 */
int filesub(void)
	{
	long	fcount;
	FILE	*fpi, *fpo;

	/* 摜xTCỸ`FbNA0`31̓G[Ƃ */
	if	(header.dx < 32)
		{
		printf	("摜xTCY(%d)32ȏɂĉ\n", header.dx);
		return	(-1);
		}

	/* ̓t@CI[v */
	strcpy	(FName, InName);	strcat	(FName, ".RAW");
	if	((fpi= fopen(FName, "rb")) == NULL)
		{
		printf	("̓t@C(%s)I[vł܂\n", FName);
		return	(-1);
		}

	/* ̓t@C̃TCY𓾂 */
	if	(fseek(fpi, 0L, SEEK_END) != 0)
		return	(-1);
	if	((fcount= ftell(fpi)) < 24L)
		{
		printf	("̓t@C(%s)̓eُł\n", FName);
		return	(-1);
		}
	fseek	(fpi, 0L, SEEK_SET);

	header.dy= (short)(fcount / (long)header.dx / 3L);
	printf	("摜yTCY %dł.\n", header.dy);
	
	/* o̓t@CI[v */
	strcpy	(FName, OutName);	strcat	(FName, ".R16");
	if	((fpo= fopen(FName, "wb")) == NULL)
		{
		fclose	(fpi);
		printf	("o̓t@C(%s)I[vł܂\n", FName);
		return	(-1);
		}

	/* ϊt@C̏\ */
	printf	("\nRaw2R16 Converter V1.0 By Y.Kyotani\n");
	printf	("\t%s.RAW(16M RGB:%ldBytes) --> %s.R16(16Bit:565bgr)\n\n", InName, fcount, OutName);

	/* wb_[̏ */
	if	(fwrite(&header, sizeof(header), 1, fpo) != 1)
		{
		fclose	(fpi);	fclose	(fpo);
		printf	("o̓t@C(%s)̏݃G[ł\n", FName);
		return	(-1);
		}

	/* f[^{̂ϊȂϊďo */
	while	(fread(inbuff, 3, 1, fpi) == 1)
		{
		// inbuff[0] --> rrrrrrrr, inbuff[1] --> gggggggg, inbuff[2] --> bbbbbbbb
		// outbuff[0] -> bbbbbggg, outbuff[1] -> gggrrrrr
		outbuff[0]= inbuff[2] & 0xf8;		// bbbbb000
		outbuff[0] |= inbuff[1] >> 5;		// bbbbbggg
		outbuff[1]= (inbuff[1] & 0x1c) << 3;	// ggg00000
		outbuff[1] |= inbuff[0] >> 3;		// gggrrrrr
		
		if	(fwrite(outbuff, 2, 1, fpo) != 1)
			{
			fclose	(fpi);	fclose	(fpo);
			printf	("o̓t@C(%s)̏݃G[ł\n", FName);
			return	(-1);
			}
		}

	/* Filler߂̏ */
	fcount= (long)header.dx * (long)header.dy *2L;
	if	(fcount %= 512L)
		{
		memset	(FName, 0, sizeof(FName));
		fwrite	(FName, (size_t)(512L-fcount), 1, fpo);
		}
	

	/* t@CN[YďI */
	fclose	(fpi);
	fclose	(fpo);
	return	(0);
	}

