
/* ---------------------------------------------

	[ main.c ]

	RGS15AP C[`
	(c) 2010, By Y.Kyotani

--------------------------------------------- */

#include	<string.h>
#include	<avr/io.h>
#include	<avr/pgmspace.h>
#include	<avr/interrupt.h>
#include	"diskio.h"
#include	"pff.h"

#include	"oledsub.h"
#include	"timer168.h"
#include	"fileio.h"
#include	"keyin.h"

/* ---------------------------------------------

	C[`

--------------------------------------------- */
int main (void)
	{
	FRESULT	res;
	FATFS	fs;
	
	PORTB = 0b00101100;	// __1_1100
	DDRB  = 0b00101100;	// oooIooII
	
	PORTC = 0b00011111;	// 00011111
	DDRC  = 0b11111111;	// oooooooo
	
	PORTD = 0b00000000;	// 00000000
	DDRD  = 0b11111111;	// oooooooo
	
	/* ȅ */
	TimerInit	();			// ^C}[ON
	sei		();
	OLEDInit	();			// OLEDRg[[
	GCls		(0x0000);		// ʏ
	OLEDDispON	();			// OLED\X^[g

	for	( ; ; )
		{
		/* Petit-FatFsщʃ[`̏ */
		while	((res= pf_mount(&fs)) != FR_OK)
			{			// pf_mount()disk_initialize()s
			
			PutRCOK	(res, 0);	// G[e\ƊmF҂
			GCls	(0x0000);	// G[\ăgC
			}
		
		/* SDJ[h̃t@CLɂă[h肷 */
		
		/* ftHgV[PXt@C"DEFAULT.SEQ"s */
		if	((res=ProcessDefaultSeqFile()) != FR_OK)
			continue;		// psG[
		
		/* t@CꗗǂݏođIꂽACes */
		if	((res=ProcessFList()) != FR_OK)
			continue;		// psG[
						// 펞͊{IɂɔłȂ
		}
	}

// End of main.c
