
/* ---------------------------------------------

	[ raw2asm.c ]

	^LCD/OLEDpt@CtH[}bgϊ
	for Win32vbgtH[
	(c) 2010, By Y.Kyotani

--------------------------------------------- */

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

/* ϐ` */
char	InName[128];
char	OutName[128];
char	FName[256];

unsigned char	fbuff[128];

/* [J֐vg^Cv */
int filesub1(void);
int filesub2(void);
int filesub3(void);


/* C֐F̉H */
int main(int argc, char *argv[])
	{
	if	(argc < 2)
		{
		printf	("̓t@C(*.raw)gqȂœ́F");
		gets	(InName);
		}
	else
		strcpy	(InName, argv[1]);

	if	(argc < 3)
		{
		printf	("o̓t@C(*.S)gqȂœ́F");
		gets	(OutName);
		}
	else
		strcpy	(OutName, argv[2]);

	if	(argc < 4)
		{
		printf	("o̓tH[}bgI(1->8Bit:bgr233, 2->8Bit:grb332, 3->16Bit:bgr565)F");
		gets	(FName);
		}
	else
		strcpy	(FName, argv[3]);
	
	switch	(atoi(FName))
		{
		case	1:
			return	(filesub1());
		case	2:
			return	(filesub2());
		case	3:
			return	(filesub3());
		default:
			return	0;
		}
	}

/* t@CJĉH鏈(8Bit:bgr233) */
int filesub1(void)
	{
	long		fcount;
	unsigned int	fwork, floop;
	FILE		*fpi, *fpo;

	/* ̓t@CI[v */
	strcpy	(FName, InName);	strcat	(FName, ".raw");
	if	((fpi= fopen(FName, "rb")) == NULL)
		{
		printf	("̓t@C(%s)I[vł܂\n", FName);
		return	(-1);
		}

	/* ̓t@C̃TCY𓾂 */
	if	(fseek(fpi, 0L, SEEK_END) != 0)
		return	(-1);
	if	((fcount= ftell(fpi)) < 24L)
		{
		printf	("̓t@C(%s)̓eُł\n", FName);
		return	(-1);
		}
	fseek	(fpi, 0L, SEEK_SET);

	/* o̓t@CI[v */
	strcpy	(FName, OutName);	strcat	(FName, ".S");
	if	((fpo= fopen(FName, "w")) == NULL)
		{
		fclose	(fpi);
		printf	("o̓t@C(%s)I[vł܂\n", FName);
		return	(-1);
		}

	/* o͂eLXg擪ɒ^𖄂ߍ */
	fprintf	(fpo, ";\n;\t[ %s.S ]\n;\n;\tRaw2Asm Converter V1.0 By Y.Kyotani\n", OutName);
	fprintf	(fpo, ";\t%s.raw(16M RGB:%ldBytes) --> %s.S(8Bit:bbgggrrr)\n;\n", InName, fcount, OutName);
	fprintf	(fpo, "\n\t.section\t.text\n\n.global\t%s\n%s:\n", OutName, OutName);

	/* f[^{̂ϊȂ琮`ďo */
	floop= 0;
	for	( ; ; )
		{
		if	(fread(fbuff, 3, 1, fpi) != 1)
			break;
		
		// fbuff[0] --> r, fbuff[1] --> g, fbuff[2] --> b
		fwork  = fbuff[2] & 0xc0;		// 00000000 bb000000
		fwork |= (fbuff[1] & 0xe0) >> 2;	// 00000000 bbggg000
		fwork |= (fbuff[0] & 0xe0) >> 5;	// 00000000 bbgggrrr

		if	(floop == 0)
			fprintf	(fpo, "\t.dc.b\t");
		else
			fprintf	(fpo, ",");
		fprintf	(fpo, "0x%02x", fwork);
		
		floop = (floop+1) & 0x07;
		
		if	(floop == 0)
			fprintf	(fpo, "\n");
		}

	if	(floop != 0)
		fprintf	(fpo, "\n");

	/* o͂eLXgɒ^𖄂ߍ */
	fprintf	(fpo, "\n\t.align\t2\n");
	fprintf	(fpo, "\n;\tEnd of %s.S\n", OutName);

	/* t@CN[YďI */
	fclose	(fpi);
	fclose	(fpo);
	return	(0);
	}

/* t@CJĉH鏈(8Bit:grb332) */
int filesub2(void)
	{
	long		fcount;
	unsigned int	fwork, floop;
	FILE		*fpi, *fpo;

	/* ̓t@CI[v */
	strcpy	(FName, InName);	strcat	(FName, ".raw");
	if	((fpi= fopen(FName, "rb")) == NULL)
		{
		printf	("̓t@C(%s)I[vł܂\n", FName);
		return	(-1);
		}

	/* ̓t@C̃TCY𓾂 */
	if	(fseek(fpi, 0L, SEEK_END) != 0)
		return	(-1);
	if	((fcount= ftell(fpi)) < 24L)
		{
		printf	("̓t@C(%s)̓eُł\n", FName);
		return	(-1);
		}
	fseek	(fpi, 0L, SEEK_SET);

	/* o̓t@CI[v */
	strcpy	(FName, OutName);	strcat	(FName, ".S");
	if	((fpo= fopen(FName, "w")) == NULL)
		{
		fclose	(fpi);
		printf	("o̓t@C(%s)I[vł܂\n", FName);
		return	(-1);
		}

	/* o͂eLXg擪ɒ^𖄂ߍ */
	fprintf	(fpo, ";\n;\t[ %s.S ]\n;\n;\tRaw2Asm Converter V1.0 By Y.Kyotani\n", OutName);
	fprintf	(fpo, ";\t%s.raw(16M RGB:%ldBytes) --> %s.S(8Bit:gggrrrbb)\n;\n", InName, fcount, OutName);
	fprintf	(fpo, "\n\t.section\t.text\n\n.global\t%s\n%s:\n", OutName, OutName);

	/* f[^{̂ϊȂ琮`ďo */
	floop= 0;
	for	( ; ; )
		{
		if	(fread(fbuff, 3, 1, fpi) != 1)
			break;
		
		// fbuff[0] --> r, fbuff[1] --> g, fbuff[2] --> b
		fwork  = fbuff[1] & 0xe0;		// 00000000 ggg00000
		fwork |= (fbuff[0] & 0xe0) >> 3;	// 00000000 gggrrr00
		fwork |= (fbuff[2] & 0xc0) >> 6;	// 00000000 gggrrrbb

		if	(floop == 0)
			fprintf	(fpo, "\t.dc.b\t");
		else
			fprintf	(fpo, ",");
		fprintf	(fpo, "0x%02x", fwork);
		
		floop = (floop+1) & 0x07;
		
		if	(floop == 0)
			fprintf	(fpo, "\n");
		}

	if	(floop != 0)
		fprintf	(fpo, "\n");

	/* o͂eLXgɒ^𖄂ߍ */
	fprintf	(fpo, "\n\t.align\t2\n");
	fprintf	(fpo, "\n;\tEnd of %s.S\n", OutName);

	/* t@CN[YďI */
	fclose	(fpi);
	fclose	(fpo);
	return	(0);
	}

/* t@CJĉH鏈(16Bit:bgr565) */
int filesub3(void)
	{
	long		fcount;
	unsigned int	fwork1, fwork2, floop;
	FILE		*fpi, *fpo;

	/* ̓t@CI[v */
	strcpy	(FName, InName);	strcat	(FName, ".raw");
	if	((fpi= fopen(FName, "rb")) == NULL)
		{
		printf	("̓t@C(%s)I[vł܂\n", FName);
		return	(-1);
		}

	/* ̓t@C̃TCY𓾂 */
	if	(fseek(fpi, 0L, SEEK_END) != 0)
		return	(-1);
	if	((fcount= ftell(fpi)) < 24L)
		{
		printf	("̓t@C(%s)̓eُł\n", FName);
		return	(-1);
		}
	fseek	(fpi, 0L, SEEK_SET);

	/* o̓t@CI[v */
	strcpy	(FName, OutName);	strcat	(FName, ".S");
	if	((fpo= fopen(FName, "w")) == NULL)
		{
		fclose	(fpi);
		printf	("o̓t@C(%s)I[vł܂\n", FName);
		return	(-1);
		}

	/* o͂eLXg擪ɒ^𖄂ߍ */
	fprintf	(fpo, ";\n;\t[ %s.S ]\n;\n;\tRaw2Asm Converter V1.0 By Y.Kyotani\n", OutName);
	fprintf	(fpo, ";\t%s.raw(16M RGB:%ldBytes) --> %s.S(16Bit:bbbbbggggggrrrrr)\n;\n", InName, fcount, OutName);
	fprintf	(fpo, "\n\t.section\t.text\n\n.global\t%s\n%s:\n", OutName, OutName);

	/* f[^{̂ϊȂ琮`ďo */
	floop= 0;
	for	( ; ; )
		{
		if	(fread(fbuff, 3, 1, fpi) != 1)
			break;
		
		// fbuff[0] --> r, fbuff[1] --> g, fbuff[2] --> b
		fwork1  = fbuff[2] & 0xf8;		// 00000000 bbbbb000
		fwork1 |= fbuff[1] >> 5;		// 00000000 bbbbbggg
		fwork2  =(fbuff[1] & 0x1c) << 3;	// 00000000 ggg00000
		fwork2 |= fbuff[0] >> 3;		// 00000000 gggrrrrr

		if	(floop == 0)
			fprintf	(fpo, "\t.dc.b\t");
		else
			fprintf	(fpo, ",");
		fprintf	(fpo, "0x%02x,0x%02x", fwork1, fwork2);
		
		floop = (floop+1) & 0x07;
		
		if	(floop == 0)
			fprintf	(fpo, "\n");
		}

	if	(floop != 0)
		fprintf	(fpo, "\n");

	/* o͂eLXgɒ^𖄂ߍ */
	fprintf	(fpo, "\n\t.align\t2\n");
	fprintf	(fpo, "\n;\tEnd of %s.S\n", OutName);

	/* t@CN[YďI */
	fclose	(fpi);
	fclose	(fpo);
	return	(0);
	}
