/* ---------------------------------------------

	[ oledsub.h ]

	OLED`֘ATu[`

--------------------------------------------- */

#define		GC_ESCAPE	0xfe		/* @\s */
#define		GC_BOXF		0x01		/* BOXF, xh, x, y, dxh, dx, dy */
#define		GC_BGCOLOR	0x02		/* BGCOLOR r, g, b */
#define		GC_FGCOLOR	0x03		/* FGCOLOR r, g, b */
#define		GC_LOCATE	0x04		/* LOCATE xh, x, y */
#define		GC_IMGCHR	0x05		/* IMGCHR d0, d1, d2, d3, d4, d5, d6, d7 */

#define		GCE_BOXF	0xfe,0x01	/* ESCAPE, BOXF, xh, x, y, dxh, dx, dy */
#define		GCE_BGCOLOR	0xfe,0x02	/* ESCAPE, BGCOLOR r, g, b */
#define		GCE_FGCOLOR	0xfe,0x03	/* ESCAPE, FGCOLOR r, g, b */
#define		GCE_LOCATE	0xfe,0x04	/* ESCAPE, LOCATE xh, x, y */
#define		GCE_IMGCHR	0xfe,0x05	/* ESCAPE, IMGCHR d0, d1, d2, ... , d7 */

#define		GSTR_BOXF	"\xfe\x01"
#define		GSTR_BGCOLOR	"\xfe\x02"
#define		GSTR_FGCOLOR	"\xfe\x03"
#define		GSTR_LOCATE	"\xfe\x04"
#define		GSTR_IMGCHR	"\xfe\x05"

void OLEDInit(void);
void OLEDDispON(void);
void OLEDDispOFF(void);

int  SetWindowArea(int dx, int dy, int ofstx, int ofsty);
void SetWindowParam(WORD x1, WORD y1, WORD x2, WORD y2);
void InitWindowArea(void);

void GCls(WORD col);
void OLEDFill(DWORD len, WORD col);
void OLEDTrans(BYTE *buff, WORD len);
void MMC2OLEDDirect(WORD len);

void OLEDFillBox(WORD x, WORD y, WORD dx, WORD dy, WORD color);
void OLEDSetLocate(WORD x, WORD y);
void OLEDPutChr(char chr);

void OLEDPutStr(const prog_char *str);
void OLEDFixWStr(char *str, WORD width);


// End of oledsub.h
